#include "adc.h"

void ADC_init(void)
{
	// intrerupt enables
	ADMUX |= (1 << REFS0);
	ADCSRA |= (1 << ADEN) | (1 << ADIE) | (7 << ADPS0);
}

uint16_t ADC_get(uint8_t ch)
{
	ADMUX &= 0b11111000;
   //Select ADC Channel ch must be 0-7
   ch=ch&0b00000111;
   ADMUX|=ch;

   //Start Single conversion
   ADCSRA|=(1<<ADSC);

   //Wait for conversion to complete
   while(!(ADCSRA & (1<<ADIF)));

   //Clear ADIF by writing one to it
   ADCSRA|=(1<<ADIF);

   return(ADC);
}

double ADC_voltage(int raw)
{
	(void)raw;
	// TODO 2
	return raw * ADC_AREF_VOLTAGE / 1023.0;
}